//
//  Timer_BeginWatch.m
//  timer
//
//  Created by 郑琳 on 16/6/22.
//  Copyright © 2016年 郑琳. All rights reserved.
//

#import "Timer_BeginWatch.h"

#define kDefaultFireIntervalNormal  0.001
@interface Timer_BeginWatch()

@property (weak, nonatomic) NSTimer *timer;
@property (strong,nonatomic) NSDate *date;//初始的系统当前时间

@end
@implementation Timer_BeginWatch
-(instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        
    }
    return self;
}


-(void)start{
    if(!_timer){
        _date  = [NSDate date];
        _timer = [NSTimer scheduledTimerWithTimeInterval:kDefaultFireIntervalNormal target:self selector:@selector(labelWithTimerSpan) userInfo:nil repeats:YES];
           
         [[NSRunLoop mainRunLoop] addTimer:_timer forMode:NSRunLoopCommonModes];
    }

}

-(void)labelWithTimerSpan{
    //执行该方法时获取系统的时间
    
    NSDate *NewDate = [NSDate date];
    
    NSTimeInterval late = [_date timeIntervalSince1970]*1;
    NSTimeInterval now = [NewDate timeIntervalSince1970]*1;
    //用新获取的系统时间减去初始的系统时间 得到一个时间差.（_date = [NSDate date] 没有设置 _date这个值本应是刚来到某个控制器页面时获取的时间值）
    NSTimeInterval cha=now-late;

    NSInteger timer = (NSInteger)(cha *1000);
    
    NSInteger nowSpan = self.timerSpan - timer;

    //计算
    NSInteger SS = nowSpan%1000;//毫秒
    nowSpan = nowSpan/1000;
    NSInteger s = nowSpan%60;//秒
    NSInteger m = nowSpan/60;//分
    
    //判断毫秒小于0的时候
    if (nowSpan<=0) {
        self.text = @"00:00:00";
        [self stopTimer];

    }else{
        self.text = [NSString stringWithFormat:@"%02ld:%02ld:%02ld",m,s,SS/10];
    }
    
}

-(void)stopTimer{
    [_timer invalidate];//释放计时器
    _timer = nil;
    
    
    if (_delegate && [_delegate respondsToSelector:@selector(timeFinished)]) {
        [_delegate timeFinished];
    }

}


@end
